/*
 * Created on 2019-08-18 ( Time 17:15:12 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "ordre_reparation"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="ordre_reparation" )
public class OrdreReparation implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_chef_atelier_ordre")
    private Boolean    isValidedByChefAtelierOrdre ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_chef_atelier_travaux")
    private Boolean    isValidedByChefAtelierTravaux ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_reception")
    private Boolean    isValidedByReception ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_superviseur_ordre")
    private Boolean    isValidedBySuperviseurOrdre ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_superviseur_travaux")
    private Boolean    isValidedBySuperviseurTravaux ;

	/*
	 * 
	 */
    @Column(name="observations_chef_atelier")
    private String     observationsChefAtelier ;

	/*
	 * 
	 */
    @Column(name="observations_superviseur")
    private String     observationsSuperviseur ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_reception")
    private Date       dateValidationReception ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_ordre_chef_atelier")
    private Date       dateValidationOrdreChefAtelier ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_travaux_chef_atelier")
    private Date       dateValidationTravauxChefAtelier ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_ordre_superviseur")
    private Date       dateValidationOrdreSuperviseur ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_travaux_superviseur")
    private Date       dateValidationTravauxSuperviseur ;

	// "ficheReceptionId" (column "fiche_reception_id") is not defined by itself because used as FK in a link 
	// "typeOrdreReparationId" (column "type_ordre_reparation_id") is not defined by itself because used as FK in a link 
	// "etatTravauxId" (column "etat_travaux_id") is not defined by itself because used as FK in a link 
	// "etatOrdreId" (column "etat_ordre_id") is not defined by itself because used as FK in a link 
	// "userChefAtelierId" (column "user_chef_atelier_id") is not defined by itself because used as FK in a link 
	// "userSuperviseurId" (column "user_superviseur_id") is not defined by itself because used as FK in a link 
	// "userReceptionId" (column "user_reception_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="user_superviseur_id", referencedColumnName="id")
    private User userSuperviseur       ;
    @ManyToOne
    @JoinColumn(name="type_ordre_reparation_id", referencedColumnName="id")
    private TypeOrdreReparation typeOrdreReparation;
    @ManyToOne
    @JoinColumn(name="etat_ordre_id", referencedColumnName="id")
    private Etat etatOrdre        ;
    @ManyToOne
    @JoinColumn(name="fiche_reception_id", referencedColumnName="id")
    private FicheReception ficheReception;
    @ManyToOne
    @JoinColumn(name="etat_travaux_id", referencedColumnName="id")
    private Etat etatTravaux       ;
    @ManyToOne
    @JoinColumn(name="user_chef_atelier_id", referencedColumnName="id")
    private User userChefAtelier        ;
    @ManyToOne
    @JoinColumn(name="user_reception_id", referencedColumnName="id")
    private User userReception       ;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public OrdreReparation() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }

    //--- DATABASE MAPPING : is_valided_by_chef_atelier_ordre ( BIT ) 
    public void setIsValidedByChefAtelierOrdre( Boolean isValidedByChefAtelierOrdre ) {
        this.isValidedByChefAtelierOrdre = isValidedByChefAtelierOrdre;
    }
    public Boolean getIsValidedByChefAtelierOrdre() {
        return this.isValidedByChefAtelierOrdre;
    }

    //--- DATABASE MAPPING : is_valided_by_chef_atelier_travaux ( BIT ) 
    public void setIsValidedByChefAtelierTravaux( Boolean isValidedByChefAtelierTravaux ) {
        this.isValidedByChefAtelierTravaux = isValidedByChefAtelierTravaux;
    }
    public Boolean getIsValidedByChefAtelierTravaux() {
        return this.isValidedByChefAtelierTravaux;
    }

    //--- DATABASE MAPPING : is_valided_by_reception ( BIT ) 
    public void setIsValidedByReception( Boolean isValidedByReception ) {
        this.isValidedByReception = isValidedByReception;
    }
    public Boolean getIsValidedByReception() {
        return this.isValidedByReception;
    }

    //--- DATABASE MAPPING : is_valided_by_superviseur_ordre ( BIT ) 
    public void setIsValidedBySuperviseurOrdre( Boolean isValidedBySuperviseurOrdre ) {
        this.isValidedBySuperviseurOrdre = isValidedBySuperviseurOrdre;
    }
    public Boolean getIsValidedBySuperviseurOrdre() {
        return this.isValidedBySuperviseurOrdre;
    }

    //--- DATABASE MAPPING : is_valided_by_superviseur_travaux ( BIT ) 
    public void setIsValidedBySuperviseurTravaux( Boolean isValidedBySuperviseurTravaux ) {
        this.isValidedBySuperviseurTravaux = isValidedBySuperviseurTravaux;
    }
    public Boolean getIsValidedBySuperviseurTravaux() {
        return this.isValidedBySuperviseurTravaux;
    }

    //--- DATABASE MAPPING : observations_chef_atelier ( TEXT ) 
    public void setObservationsChefAtelier( String observationsChefAtelier ) {
        this.observationsChefAtelier = observationsChefAtelier;
    }
    public String getObservationsChefAtelier() {
        return this.observationsChefAtelier;
    }

    //--- DATABASE MAPPING : observations_superviseur ( TEXT ) 
    public void setObservationsSuperviseur( String observationsSuperviseur ) {
        this.observationsSuperviseur = observationsSuperviseur;
    }
    public String getObservationsSuperviseur() {
        return this.observationsSuperviseur;
    }

    //--- DATABASE MAPPING : date_validation_reception ( DATETIME ) 
    public void setDateValidationReception( Date dateValidationReception ) {
        this.dateValidationReception = dateValidationReception;
    }
    public Date getDateValidationReception() {
        return this.dateValidationReception;
    }

    //--- DATABASE MAPPING : date_validation_ordre_chef_atelier ( DATETIME ) 
    public void setDateValidationOrdreChefAtelier( Date dateValidationOrdreChefAtelier ) {
        this.dateValidationOrdreChefAtelier = dateValidationOrdreChefAtelier;
    }
    public Date getDateValidationOrdreChefAtelier() {
        return this.dateValidationOrdreChefAtelier;
    }

    //--- DATABASE MAPPING : date_validation_travaux_chef_atelier ( DATETIME ) 
    public void setDateValidationTravauxChefAtelier( Date dateValidationTravauxChefAtelier ) {
        this.dateValidationTravauxChefAtelier = dateValidationTravauxChefAtelier;
    }
    public Date getDateValidationTravauxChefAtelier() {
        return this.dateValidationTravauxChefAtelier;
    }

    //--- DATABASE MAPPING : date_validation_ordre_superviseur ( DATETIME ) 
    public void setDateValidationOrdreSuperviseur( Date dateValidationOrdreSuperviseur ) {
        this.dateValidationOrdreSuperviseur = dateValidationOrdreSuperviseur;
    }
    public Date getDateValidationOrdreSuperviseur() {
        return this.dateValidationOrdreSuperviseur;
    }

    //--- DATABASE MAPPING : date_validation_travaux_superviseur ( DATETIME ) 
    public void setDateValidationTravauxSuperviseur( Date dateValidationTravauxSuperviseur ) {
        this.dateValidationTravauxSuperviseur = dateValidationTravauxSuperviseur;
    }
    public Date getDateValidationTravauxSuperviseur() {
        return this.dateValidationTravauxSuperviseur;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setUserSuperviseur( User userSuperviseur ) {
        this.userSuperviseur = userSuperviseur;
    }
    public User getUserSuperviseur() {
        return this.userSuperviseur;
    }


    public void setTypeOrdreReparation( TypeOrdreReparation typeOrdreReparation ) {
        this.typeOrdreReparation = typeOrdreReparation;
    }
    public TypeOrdreReparation getTypeOrdreReparation() {
        return this.typeOrdreReparation;
    }


    public void setEtatOrdre( Etat etatOrdre ) {
        this.etatOrdre = etatOrdre;
    }
    public Etat getEtatOrdre() {
        return this.etatOrdre;
    }


    public void setFicheReception( FicheReception ficheReception ) {
        this.ficheReception = ficheReception;
    }
    public FicheReception getFicheReception() {
        return this.ficheReception;
    }


    public void setEtatTravaux( Etat etatTravaux ) {
        this.etatTravaux = etatTravaux;
    }
    public Etat getEtatTravaux() {
        return this.etatTravaux;
    }


    public void setUserChefAtelier( User userChefAtelier ) {
        this.userChefAtelier = userChefAtelier;
    }
    public User getUser() {
        return this.userChefAtelier;
    }


    public void setUserReception( User userReception ) {
        this.userReception = userReception;
    }
    public User getUserReception() {
        return this.userReception;
    }


    public User getUserChefAtelier() {
		return userChefAtelier;
	}

	//----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        sb.append("|");
        sb.append(isValidedByChefAtelierOrdre);
        sb.append("|");
        sb.append(isValidedByChefAtelierTravaux);
        sb.append("|");
        sb.append(isValidedByReception);
        sb.append("|");
        sb.append(isValidedBySuperviseurOrdre);
        sb.append("|");
        sb.append(isValidedBySuperviseurTravaux);
        // attribute 'observationsChefAtelier' not usable (type = String Long Text)
        // attribute 'observationsSuperviseur' not usable (type = String Long Text)
        sb.append("|");
        sb.append(dateValidationReception);
        sb.append("|");
        sb.append(dateValidationOrdreChefAtelier);
        sb.append("|");
        sb.append(dateValidationTravauxChefAtelier);
        sb.append("|");
        sb.append(dateValidationOrdreSuperviseur);
        sb.append("|");
        sb.append(dateValidationTravauxSuperviseur);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
